class Result

  attr_reader :type, :msg, :counter, :output
  attr_reader :min, :max, :middle, :all

  alias message msg

  def initialize( type, message )
    @type = type.to_sym
    @msg  = message
    @all  = []
  end

  def add( start, ends )
    time = ends.to_f - start.to_f
    @all << time
  end

  def get
    @counter = @all.size
    @min     = get_by_type @all.min
    @max     = get_by_type @all.max
    @middle  = get_by_type ( @max - ( (@max - @min) / 2 ) )
    @output  = create_result_message
  end

  def create_result_message
    msg = @msg.to_s
    msg += " => "
    msg += "min: #{@min} #{@type} | max: #{@max} #{@type} | middle: #{@middle} #{@type}"
  end

  private

  def get_by_type( time )
    case @type
      when :min then x = (time / 360).round(2)
      when :ms  then x = (time * 1000).round(5)
      when :h   then x = (time / 60).round(2)
      else  x = time.round(4)
    end
    return x
  end

end
